declare type EventAdd = {
    action: 0;
    directory: string;
    file: string;
};
declare type EventUnlink = {
    action: 1;
    directory: string;
    file: string;
};
declare type EventChange = {
    action: 2;
    directory: string;
    file: string;
};
declare type EventRename = {
    action: 3;
    directory: string;
    oldFile: string;
    newDirectory: string;
    newFile: string;
};
declare type Event = EventAdd | EventUnlink | EventChange | EventRename;
declare type Options = {
    debounceMS?: number;
    errorCallback?: Function;
};
declare type Handlers = {
    add?: (filePath: string) => void;
    unlink?: (filePath: string) => void;
    change?: (filePath: string) => void;
    rename?: (prevFilePath: string, nextFilePath: string) => void;
};
declare type Listener = {
    start(): Promise<void>;
    stop(): Promise<void>;
};
export { EventAdd, EventUnlink, EventChange, EventRename, Event, Options, Handlers, Listener };
